/* ----- BEGIN LICENSE BLOCK -----
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Kagetaka Libraries.
 *
 * The Initial Developer of the Original Code is Hizuya Atsuzaki
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Hizuya Atsuzaki <hizuya@hizlab.net>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ----- END LICENSE BLOCK ----- */
package net.hizlab.kagetaka.rendering;

import net.hizlab.kagetaka.Reporter;
import net.hizlab.kagetaka.Resource;
import net.hizlab.kagetaka.token.FormItem;
import net.hizlab.kagetaka.util.Environment;

import java.awt.CheckboxMenuItem;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Menu;
import java.awt.MenuItem;
import java.awt.Point;
import java.awt.PopupMenu;
import java.awt.SystemColor;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.StringSelection;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.AdjustmentEvent;
import java.awt.event.AdjustmentListener;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;
import java.awt.event.InputEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;
import java.net.URL;
import java.util.Vector;

/**
 * 襭ѥѥڥǤ
 * ϲ̱νĽɽʤΤǡ
 * ꥵʤɤԤޤ
 * 
 * @author  <A HREF="mailto:hizuya@hizlab.net">Hizuya Atsuzaki</A>
 * @version $Revision: 1.14 $
 */
public class HawkPanel
	extends Container
{
	private static final long RESIZE_WAIT = 10000;
	private static final long TIP_DELAY   =   700;
	private static final long TIP_TERM    =  5000;
	private static final long EVENT_DELAY =    30;
	
	private static final int MENU_MENU  = 0;
	private static final int MENU_ITEM  = 1;
	private static final int MENU_CHECK = 2;
	
	private static final int    MENU_SEPARATOR                  = -1;
	/** ᥤ˥塼 */
	public  static final String MENU_MAIN_BACK                  =  "canvas.menu.main.back";
	private static final int    MENU_MAIN_BACK_INDEX            =  2;
	/** ᥤ󡦼ؿʤ˥塼 */
	public  static final String MENU_MAIN_FORWARD               =  "canvas.menu.main.forward";
	private static final int    MENU_MAIN_FORWARD_INDEX         =  3;
	/** ᥤߥ˥塼 */
	public  static final String MENU_MAIN_STOP                  =  "canvas.menu.main.stop";
	private static final int    MENU_MAIN_STOP_INDEX            =  4;
	/** ᥤ󡦺ɹ˥塼 */
	public  static final String MENU_MAIN_RELOAD                =  "canvas.menu.main.reload";
	private static final int    MENU_MAIN_RELOAD_INDEX          =  5;
	/** ᥤ󡦥ץ˥塼 */
	public  static final String MENU_MAIN_OPTION                =  "canvas.menu.main.option";
	private static final int    MENU_MAIN_OPTION_INDEX          =  7;
	/** ᥤ󡦥ץ󡦲ɤ߹ޤʤ˥塼 */
	public  static final String MENU_MAIN_OPTION_IMAGE          =  "canvas.menu.main.option.image";
	private static final int    MENU_MAIN_OPTION_IMAGE_INDEX    =  8;
	/** ᥤ󡦥ץ󡦥Сɽ˥塼 */
	public  static final String MENU_MAIN_OPTION_BAR            =  "canvas.menu.main.option.bar";
	private static final int    MENU_MAIN_OPTION_BAR_INDEX      =  9;
	/** ᥤ󡦥ץGIF ž˥塼 */
	public  static final String MENU_MAIN_OPTION_SPINGIF        = "canvas.menu.main.option.spingif";
	private static final int    MENU_MAIN_OPTION_SPINGIF_INDEX  = 10;
	/** ᥤ󡦥ץJPEG ž˥塼 */
	public  static final String MENU_MAIN_OPTION_SPINJPEG       = "canvas.menu.main.option.spinjpeg";
	private static final int    MENU_MAIN_OPTION_SPINJPEG_INDEX = 11;
	/** ᥤ󡦾˥塼 */
	public  static final String MENU_MAIN_INFO                  = "canvas.menu.main.info";
	private static final int    MENU_MAIN_INFO_INDEX            = 12;
	/** 󥯡 URL 򥳥ԡ˥塼 */
	public  static final String MENU_LINK_COPY                  = "canvas.menu.link.copy";
	private static final int    MENU_LINK_COPY_INDEX            = 24;
	/** ɽ˥塼 */
	public  static final String MENU_IMAGE_OPEN                 = "canvas.menu.image.open";
	private static final int    MENU_IMAGE_OPEN_INDEX           = 32;
	/**  URL 򥳥ԡ˥塼 */
	public  static final String MENU_IMAGE_COPY                 = "canvas.menu.image.copy";
	private static final int    MENU_IMAGE_COPY_INDEX           = 33;
	
	private static final int    MENU_SIZE                       = 34;
	
	/** Υ */
	public  static final int SCROLL_HORIZONTAL = 1;
	/** Υ */
	public  static final int SCROLL_VERTICAL   = 2;
	/** ˥åñ̤ǤΥ */
	public  static final int SCROLL_UNIT       = 0;
	/** ֥åñ̤ǤΥ */
	public  static final int SCROLL_BLOCK      = 1;
	
	
	//### 
	/** @serial 륳ƥ */
	private HawkContext    hawkContext;
	/** @serial ץ */
	private Option         option;
	/** @serial 쥤 */
	private GridBagLayout  gbl;
	/** @serial 륭ѥ */
	private Canvas         canvas;
	/** @serial С */
	private PanelScrollbar horizontal;
	/** @serial ĥС */
	private PanelScrollbar vertical;
	/** @serial Сɲäɤ */
	private boolean        horizontalAdded;
	/** @serial ĥСɲäɤ */
	private boolean        verticalAdded;
	/** @serial ġåפȤ */
	private boolean        toolTipUse   = true;
	/** @serial ġåפɽޤǤԤ */
	private long           toolTipDelay = TIP_DELAY;
	/** @serial ġå׾äޤǤԤ */
	private long           toolTipTerm  = TIP_TERM;
	
	//### 
	/** @serial ѥ */
	private Dimension  canvasSize;
	/** @serial ӥ塼ݡȥ */
	private Dimension  viewportSize;
	/** @serial 褹뱦ΰ */
	private Point      position;
	
	//### ˥塼
	/** @serial ƥȥ˥塼 */
	private PopupMenu  popupMenu;
	/** @serial ƥȥ˥塼ƥ */
	private MenuItem[] menuItems;
	/** @serial ᥤΥ˥塼ƥ */
	private Vector     mainMenuItems  = new Vector();
	/** @serial 󥯤Υ˥塼ƥ */
	private Vector     linkMenuItems  = new Vector();
	/** @serial ᡼Υ˥塼ƥ */
	private Vector     imageMenuItems = new Vector();
	
	//### 
	/** @serial ʸȹ⤵ */
	private Dimension     charScale;
	/** @serial ꥹ */
	private PanelListener listener;
	
	//### 
	/** @serial å */
	private Object cursorLock          = new Object();
	/** @serial ǥեȤΥ륿 */
	private int    defaultCursorType   = Cursor.DEFAULT_CURSOR;
	/** @serial Ūʥ륿 */
	private int    temporaryCursorType = Cursor.DEFAULT_CURSOR;
	/** @serial ɽΥ륿 */
	private int    cursorType          = Cursor.DEFAULT_CURSOR;
	
	//### 󥯡ݥåץåץƥ
	/** @serial ꥯ */
	private Request request;
	/** @serial Υ */
	private URL     currentLink;
	/** @serial β */
	private URL     currentImage;
	/** @serial ƥޥå */
	private ItemMap itemMap;
	
	//### ¾
	/** @serial 롼 */
	private boolean callRequestFocus;
	
	/**
	 * 襭ѥѥڥޤ
	 * 
	 * @param     hawkContext 륳ƥ
	 * @param     h ʿС
	 * @param     v ľС
	 */
	public HawkPanel(HawkContext hawkContext, PanelScrollbar h, PanelScrollbar v)
	{
		this.hawkContext  = hawkContext;
		this.option       = hawkContext.getOption();
		this.gbl          = new GridBagLayout();
		this.canvas       = new Canvas       (hawkContext);
		this.horizontal   = h;
		this.vertical     = v;
		this.canvasSize   = new Dimension(0, 0);
		this.viewportSize = new Dimension(0, 0);
		this.position     = new Point    (0, 0);
		this.charScale    = new Dimension(0, 0);
		
		h.addAdjustmentListener(new ScrollbarListener(ScrollbarListener.HORIZONTAL, h));
		v.addAdjustmentListener(new ScrollbarListener(ScrollbarListener.VERTICAL  , v));
		
		// ̤
		setLayout(gbl);
		GridBagConstraints gbc = new GridBagConstraints();
		addComponent(canvas, gbl, gbc, 1.0, 0, 0, GridBagConstraints.BOTH      );
		if (option.getShowScrollbar())
			fixScrollbar(true, false);
		
		super.setBackground(SystemColor.control);
		
		// ˥塼
		initMenu();
		
		// ꥹʡ
		addFocusListener(
			new FocusAdapter()
			{
				public void focusGained(FocusEvent e)
				{
					canvas.requestFocus();
				}
			}
		);
		
		canvas.addKeyListener        (new HawkCanvasKeyListener        ());
		canvas.addMouseListener      (new HawkCanvasMouseListener      ());
		canvas.addMouseMotionListener(new HawkCanvasMouseMotionListener());
		canvas.addComponentListener  (new HawkCanvasComponentListener  ());
	}
	
	/** ȥɲäޤ */
	private void addComponent(Component c, GridBagLayout gbl, GridBagConstraints gbc,
	                          double weight, int x, int y, int fill)
	{
		gbc.gridx   = x;
		gbc.gridy   = y;
		gbc.weightx = weight;
		gbc.weighty = weight;
		gbc.fill    = fill;
		gbl.setConstraints(c, gbc);
		add(c);
	}
	
	/** ˥塼 */
	private void initMenu()
	{
		Menu menu = null;
		menuItems = new MenuItem[MENU_SIZE];
		popupMenu = new PopupMenu(Resource.getMessage("canvas.menu", null));
		canvas.add(popupMenu);
		
		// ᥤ˥塼
		createMenuItem(MENU_MAIN_BACK_INDEX           , MENU_ITEM , null, mainMenuItems );
		createMenuItem(MENU_MAIN_FORWARD_INDEX        , MENU_ITEM , null, mainMenuItems );
		createMenuItem(MENU_SEPARATOR                 , MENU_ITEM , null, mainMenuItems );
		createMenuItem(MENU_MAIN_STOP_INDEX           , MENU_ITEM , null, mainMenuItems );
		createMenuItem(MENU_MAIN_RELOAD_INDEX         , MENU_ITEM , null, mainMenuItems );
		createMenuItem(MENU_SEPARATOR                 , MENU_ITEM , null, mainMenuItems );
		menu = (Menu)
		createMenuItem(MENU_MAIN_OPTION_INDEX         , MENU_MENU , null, mainMenuItems );
		createMenuItem(MENU_MAIN_OPTION_IMAGE_INDEX   , MENU_CHECK, menu, null          );
		createMenuItem(MENU_MAIN_OPTION_BAR_INDEX     , MENU_CHECK, menu, null          );
		createMenuItem(MENU_MAIN_OPTION_SPINGIF_INDEX , MENU_CHECK, menu, null          );
		createMenuItem(MENU_MAIN_OPTION_SPINJPEG_INDEX, MENU_CHECK, menu, null          );
		//### TODO
//		createMenuItem(MENU_MAIN_INFO_INDEX           , MENU_ITEM , null, mainMenuItems );
		
		// 󥯥˥塼
		createMenuItem(MENU_LINK_COPY_INDEX           , MENU_ITEM , null, linkMenuItems );
		
		// ˥塼
		createMenuItem(MENU_IMAGE_OPEN_INDEX          , MENU_ITEM , null, imageMenuItems);
		createMenuItem(MENU_IMAGE_COPY_INDEX          , MENU_ITEM , null, imageMenuItems);
	}
	
	/** ˥塼ܤ */
	private MenuItem createMenuItem(int index, int type, Menu parent, Vector items)
	{
		String menuKey = null;
		
		/// MENU
		switch (index) {
		case MENU_SEPARATOR                 : break;
		case MENU_MAIN_BACK_INDEX           : menuKey = MENU_MAIN_BACK           ; break;
		case MENU_MAIN_FORWARD_INDEX        : menuKey = MENU_MAIN_FORWARD        ; break;
		case MENU_MAIN_STOP_INDEX           : menuKey = MENU_MAIN_STOP           ; break;
		case MENU_MAIN_RELOAD_INDEX         : menuKey = MENU_MAIN_RELOAD         ; break;
		case MENU_MAIN_OPTION_INDEX         : menuKey = MENU_MAIN_OPTION         ; break;
		case MENU_MAIN_OPTION_IMAGE_INDEX   : menuKey = MENU_MAIN_OPTION_IMAGE   ; break;
		case MENU_MAIN_OPTION_BAR_INDEX     : menuKey = MENU_MAIN_OPTION_BAR     ; break;
		case MENU_MAIN_OPTION_SPINGIF_INDEX : menuKey = MENU_MAIN_OPTION_SPINGIF ; break;
		case MENU_MAIN_OPTION_SPINJPEG_INDEX: menuKey = MENU_MAIN_OPTION_SPINJPEG; break;
		case MENU_MAIN_INFO_INDEX           : menuKey = MENU_MAIN_INFO           ; break;
		case MENU_LINK_COPY_INDEX           : menuKey = MENU_LINK_COPY           ; break;
		case MENU_IMAGE_OPEN_INDEX          : menuKey = MENU_IMAGE_OPEN          ; break;
		case MENU_IMAGE_COPY_INDEX          : menuKey = MENU_IMAGE_COPY          ; break;
		default:
			Reporter reporter = hawkContext.getReporter();
			if (reporter != null)
				reporter.report(Reporter.ERROR, Resource.getMessage("internal.error", new String[]{"HawkPanel.createMenuItem", "panel menu", ""}), 0, 0);
			return null;
		}
		
		String label = (menuKey == null ? "-" : Resource.getMessage(menuKey, null));
		MenuItem mi = null;
		switch (type) {
		case MENU_MENU:
			mi = new Menu(label);
			break;
		case MENU_ITEM:
			mi = new MenuItem(label);
			if (index != MENU_SEPARATOR)
				mi.addActionListener(new MenuActionListner(index));
			break;
		case MENU_CHECK:
			mi = new CheckboxMenuItem(label);
			((CheckboxMenuItem)mi).addItemListener(new MenuActionListner(index));
			break;
		}
		
		mi.setActionCommand(menuKey != null ? menuKey : "-");
		
		if (index != MENU_SEPARATOR)
			menuItems[index] = mi;
		
		if (parent != null)
			parent.add(mi);
		if (items != null)
			items.addElement(mi);
		
		return mi;
	}
	
//### Original Method
	/**
	 * 뤷ڥΥӥ塼ݡȤ 0, 0 ֤ɽθߤ
	 * 夫 x, y ֤֤ޤ
	 * 
	 * @return    ߤΥ֤α夫κɸ
	 */
	public Point getScrollPosition()
	{
		return new Point(position.x, position.y);
	}
	
	/**
	 * ҥݡͥλꤵ줿֤إ뤷ޤ
	 * ֤ϱ夫εΥˤʤޤ
	 * 
	 * @param     x  x 
	 * @param     y  y 
	 * @param     force ֤˥ǤʤƤ⥹뤹 <code>true</code>
	 *                  ʳξ <code>false</code>
	 * 
	 * @return    뤵줿 <code>true</code>
	 *            Ǥʤä <code>false</code>
	 */
	public boolean setScrollPosition(int x, int y, boolean force)
	{
		synchronized (canvasSize) {
			if (!force &&
			    ((x > 0 && x + viewportSize.width  > canvasSize.width ) ||
			     (y > 0 && y + viewportSize.height > canvasSize.height)))
				return false;
			
			setScrollPosition(x, y);
		}
		return true;
	}
	
	/**
	 * ҥݡͥλꤵ줿ե󥹰֤إ뤷ޤ
	 * ե󥹤¸ߤʤ䡢ɤ߹ޤƤʤϰưޤ
	 * 
	 * @param     reference ե
	 * @param     force ֤˥ǤʤƤ⥹뤹 <code>true</code>
	 *                  ʳξ <code>false</code>
	 * 
	 * @return    뤵줿 <code>true</code>
	 *            Ǥʤä <code>false</code>
	 */
	public boolean setScrollPosition(String reference, boolean force)
	{
		if (reference == null || itemMap == null)
			return force;
		
		Point position = itemMap.getIdPoint(reference);
		if (position == null)
			return force;
		
		return setScrollPosition(position.x, position.y, force);
	}
	
	/**
	 * ᥤΥ˥塼ƥ֤ޤ
	 * 
	 * @return    ᥤ˥塼ƥ
	 */
	public Vector getMainMenuItems()
	{
		return mainMenuItems;
	}
	
	/**
	 * 󥯤Υ˥塼ƥ֤ޤ
	 * 
	 * @return    󥯥˥塼ƥ
	 */
	public Vector getLinkMenuItems()
	{
		return linkMenuItems;
	}
	
	/**
	 * ᡼Υ˥塼ƥ֤ޤ
	 * 
	 * @return    ᡼˥塼ƥ
	 */
	public Vector getImageMenuItems()
	{
		return imageMenuItems;
	}
	
	/**
	 * СɽƤ뤫ɤ֤ޤ
	 * 
	 * @return    ɽƤ <code>true</code>
	 *            ʳξ <code>false</code>
	 */
	public boolean isVisibleScrollbar()
	{
		synchronized (canvasSize) {
			return horizontalAdded;
		}
	}
	
	/**
	 * Сɽ뤫ɤꤷޤ
	 * 
	 * @param     b ɽ <code>true</code>
	 *              ʳξ <code>false</code>
	 */
	public void setVisibleScrollbar(boolean b)
	{
		synchronized (canvasSize) {
			// ľСϡʿСɽȤ˥ɥȤɹƼưɽ
			fixScrollbar(b, (b ? verticalAdded : false));
			option.setShowScrollbar(b);
		}
	}
	
	/**
	 * ѥͥꥹʤϿޤ
	 * 
	 * @param     listener ѥͥꥹ
	 */
	public void setPanelListener(PanelListener listener)
	{
		this.listener = listener;
	}
	
	/**
	 * ǥȥå֤ޤ
	 * 
	 * @return    ǥȥå
	 */
	public MediaTracker getMediaTracker()
	{
		return new MediaTracker(canvas);
	}
	
	/**
	 * ꡼󥤥᡼ɲäޤ
	 * 
	 * @param     image  ꡼󥤥᡼
	 * @param     width  ꡼󥤥᡼
	 * @param     height ꡼󥤥᡼ι⤵
	 */
	public void addImage(Image image, int width, int height)
	{
		synchronized (canvasSize) {
			canvasSize.width  += width;
			canvasSize.height =  Math.max(height, canvasSize.height);
			
			horizontal.setMaximum(Math.max(canvasSize.width , viewportSize.width ));
			vertical  .setMaximum(Math.max(canvasSize.height, viewportSize.height));
			
			canvas.addImage(image, width, height);
			
			if (horizontalAdded && canvasSize.height > viewportSize.height && !verticalAdded)
				fixScrollbar(true, true);
		}
	}
	
	/**
	 * եॢƥɲäޤ
	 * 
	 * @param     item եॢƥ
	 */
	public void addFormItem(FormItem item)
	{
		canvas.addFormItem(item);
	}
	
	/**
	 * ꤵ줿ꥯȤƤɽ뤿ˡѥޤ
	 * 
	 * @param     request ꥯ
	 */
	public void setupCanvas(Request request)
	{
		synchronized (canvasSize) {
			this.request = request;
			Document document = request.getDocument();
			
			canvas.setupScreen(document.getBackColor(), document.getBackImage());
			itemMap = request.getDocument().itemMap;
			canvasSize.width  = 0;
			canvasSize.height = 0;
			position.x = 0;
			position.y = 0;
			horizontal.setMaximum(viewportSize.width );
			vertical  .setMaximum(viewportSize.height);
			
			charScale = document.getCharScale();
			horizontal.setUnitIncrement (charScale.width );
			vertical  .setUnitIncrement (charScale.height);
			horizontal.setBlockIncrement(viewportSize.width  - charScale.width );
			vertical  .setBlockIncrement(viewportSize.height - charScale.height);
		}
		
		// С֤Ʊ
		if (horizontalAdded != option.getShowScrollbar() || verticalAdded) {
			synchronized (viewportSize) {
				fixScrollbar(option.getShowScrollbar(), false);
				try {
					viewportSize.wait(RESIZE_WAIT);
				} catch (InterruptedException e) {}
			}
		}
		
		resetStatus();
	}
	
	/**
	 * ѥϰϤꤷƺɽޤ
	 * ɸϱ夫εΥǤ
	 * 
	 * @param     x ѥα顢ɽ֤αüεΥ
	 * @param     y ѥξ夫顢ɽ֤ξüεΥ
	 * @param     width  ɽϰϤ
	 * @param     height ɽϰϤι⤵
	 */
	public void repaintCanvas(int x, int y, int width, int height)
	{
		synchronized (canvasSize) {
			if (canvasSize.width < x || canvasSize.height < y)
				return;
			
			canvas.repaintImage(x, y, width, height);
		}
	}
	
	/**
	 * ꤷޤ
	 * 
	 * @param     cursor 
	 */
	public void setCursor(int cursor)
	{
		setCursor(Cursor.getPredefinedCursor(cursor));
	}
	
	/**
	 * ڥΥӥ塼ݡȤθߤΥ֤ޤ
	 * 
	 * @return    ԥñ̤Υӥ塼ݡȤΥ
	 */
	public Dimension getViewportSize()
	{
		synchronized (viewportSize) {
			// ޤ֤λƤʤϡִλԤ
			if (viewportSize.width  == 0 &&
			    viewportSize.height == 0 &&
			    getParent() != null) {
				try {
					viewportSize.wait(RESIZE_WAIT);
				} catch (InterruptedException e) {}
			}
			return new Dimension(viewportSize.width, viewportSize.height);
		}
	}
	
	/**
	 * 򤵤Ƥ󥯤 URL ֤ޤ
	 * 
	 * @return    򤵤Ƥ󥯤 URL
	 *            򤵤Ƥʤ <code>null</code>
	 */
	public URL getSelectedLink()
	{
		return currentLink;
	}
	
	/**
	 * ºݤΥݡͥȤ֤ޤ
	 * Υ᥽åɤϡľܥˡ󶡤ޤ
	 * λѤˤϽʬդƤ
	 * 
	 * @return    Υݡͥ
	 */
	public Component getCanvas()
	{
		return canvas;
	}
	
	/**
	 * ꤷ̤ΥԤޤ
	 * 
	 * @param     sense 
	 * @param     type  ñ
	 * @param     value 
	 */
	public void scroll(int sense, int type, int value)
	{
		synchronized (canvasSize) {
			int x = position.x;
			int y = position.y;
			
			if (type == SCROLL_UNIT) {
				if (sense == SCROLL_HORIZONTAL)
					x += charScale.width  * value;
				else
					y += charScale.height * value;
			} else {
				if (sense == SCROLL_HORIZONTAL)
					x += (viewportSize.width  - charScale.width )  * value;
				else
					y += (viewportSize.height - charScale.height) * value;
			}
			
			setScrollPosition(x, y);
		}
	}
	
//### Override
	/**
	 * 褷ޤ
	 * 
	 * @param     g Graphics
	 */
	public void update(Graphics g)
	{
		paint(g);
	}
	
	/**
	 * 褷ޤ
	 * 
	 * @param     g Graphics
	 */
	public void paint(Graphics g)
	{
		super.paint(g);
		
		synchronized (viewportSize) {
			paintCorner(g);
		}
	}
	
	/**
	 * ݡͥȤƥʤ줿ȤΤޤ
	 */
	public void removeNotify()
	{
		super.removeNotify();
		canvas.cleanup();
	}
	
	/**
	 * ꤷޤ
	 * 
	 * @param     cursor 
	 */
	public void setCursor(Cursor cursor)
	{
		synchronized (cursorLock) {
			defaultCursorType = cursor.getType();
			
			if (temporaryCursorType == Cursor.DEFAULT_CURSOR &&
			    cursorType != defaultCursorType) {
				cursorType = defaultCursorType;
				super .setCursor(cursor);
				canvas.setCursor(cursor);
			}
		}
	}
	
	/**
	 * ġåפ򤷤ޤ
	 * 
	 * @param     use   Ѥ <code>true</code>
	 *                  ʳ <code>false</code>
	 * @param     delay ɽޤǤԤ֡ʥߥá
	 * @param     term  ɽƤ֡ʥߥá
	 */
	public void setToolTipOption(boolean use, long delay, long term)
	{
		toolTipUse   = use;
		toolTipDelay = delay;
		toolTipTerm  = term;
	}
	
	/**
	 *  ϥե׵ᤷޤ
	 */
	public void requestFocus()
	{
		if (callRequestFocus)
			return;
		callRequestFocus = true;
		
		super .requestFocus();
		canvas.requestFocus();
		
		callRequestFocus = false;
	}
	
	/**
	 * ΥڥΥѥ᡼ʸ֤ޤ
	 * 
	 * @return    ѥ᡼ʸ
	 */
	public String paramString()
	{
		String str = super.paramString();
		return str;
	}
	
//### private
	/** ҥݡͥλꤵ줿֤إץå */
	private void setScrollPosition(int x, int y)
	{
		x = Math.max(Math.min(x, canvasSize.width  - viewportSize.width ), 0);
		y = Math.max(Math.min(y, canvasSize.height - viewportSize.height), 0);
		
		if (position.x == x && position.y == y)
			return;
		
		resetStatus();
		
		position.x = x;
		position.y = y;
		
		horizontal.setValue(horizontal.getMaximum() - horizontal.getVisibleAmount() - x);
		vertical  .setValue(y);
		
		canvas.movePosition(x, y);
	}
	
	/** ˥塼˥ƥɲ */
	private void appendPopupMenuItem(Vector src)
	{
		if (src.size() == 0)
			return;
		
		if (popupMenu.getItemCount() > 0)
			popupMenu.addSeparator();
		
		MenuItem mi;
		for (int i = 0; i < src.size(); i++) {
			mi = (MenuItem)src.elementAt(i);
			if (mi.getLabel() != null && mi.getLabel().compareTo("-") != 0) {
				popupMenu.remove(mi);
			}
			popupMenu.add(mi);
		}
	}
	
	/** ꤵ줿̾Υ URL  */
	private URL getLinkURL(int x, int y)
	{
		synchronized (canvasSize) {
			if (itemMap == null)
				return null;
			
			x =  position.x + viewportSize.width - x;
			y += position.y;
			
			return itemMap.getLinkURL(x, y);
		}
	}
	
	/** ꤵ줿̾β URL  */
	private URL getImageURL(int x, int y)
	{
		synchronized (canvasSize) {
			if (itemMap == null)
				return null;
			
			x =  position.x + viewportSize.width - x;
			y += position.y;
			
			return itemMap.getImageURL(x, y);
		}
	}
	
	/** 򸵤᤹ */
	private void setTemporaryCursor(int type)
	{
		temporaryCursorType = type;
		
		if (type == Cursor.DEFAULT_CURSOR)
			type = defaultCursorType;
		
		if (cursorType != type) {
			cursorType = type;
			Cursor cursor = Cursor.getPredefinedCursor(cursorType);
			super .setCursor(cursor);
			canvas.setCursor(cursor);
		}
	}
	
	/** СĴ */
	private void fixScrollbar(boolean h, boolean v)
	{
		if (horizontalAdded == h && verticalAdded == v)
			return;
		
		GridBagConstraints gbc = new GridBagConstraints();
		
		if (horizontalAdded != h) {
			if (h)
				addComponent(horizontal.getComponent(), gbl, gbc, 0.0, 0, 1, GridBagConstraints.HORIZONTAL);
			else
				remove(horizontal.getComponent());
			horizontalAdded = h;
		}
		
		if (verticalAdded != v) {
			if (v)
				addComponent(vertical.getComponent(), gbl, gbc, 0.0, 1, 0, GridBagConstraints.VERTICAL);
			else
				remove(vertical.getComponent());
			verticalAdded = v;
		}
		validate();
		
		if (isShowing()) {
			Graphics g = getGraphics();
			if (g != null)
				try {
					paintCorner(g);
				} finally {
					g.dispose();
				}
		}
	}
	
	/** ζ */
	private void paintCorner(Graphics g)
	{
		if (verticalAdded) {
			Dimension size = getSize();
			Point     posH = horizontal.getComponent().getLocation();
			Point     posV = vertical  .getComponent().getLocation();
			g.setColor(getBackground());
			g.fillRect(posV.x, posH.y, size.width - posH.x, size.height - posV.y);
		}
	}
	
	/** ġåפץå */
	private int setupToolTip(int cursor, int x, int y)
	{
		if (toolTipUse) {
			int rx = position.x + viewportSize.width - x;
			int ry = position.y + y;
			
			String tip = null;
			if ((tip = itemMap.getInfo(rx, ry)) == null &&
			    (tip = itemMap.getTip (rx, ry)) != null)
				cursor = Cursor.CROSSHAIR_CURSOR;
			
			if (tip != null && tip.length() > 0) {
				canvas.showToolTip(tip, x, y, toolTipDelay, toolTipTerm);
				return cursor;
			}
		}
		
		canvas.clearToolTip();
		return cursor;
	}
	
	/** 򸵤᤹ */
	private void resetStatus()
	{
		setTemporaryCursor(Cursor.DEFAULT_CURSOR);
		hawkContext.setTemporaryStatus(null);
		canvas.clearToolTip();
	}
	
//### ޥ
	/** åץܡɤ˥ԡ */
	private void copyClipboard(String value)
	{
		Clipboard       clipboard = getToolkit().getSystemClipboard();
		StringSelection data      = new StringSelection(value);
		clipboard.setContents(data, data);
	}
	
//### HawkCanvasKeyListener
	/** ϥɥ */
	private class HawkCanvasKeyListener
		extends KeyAdapter
	{
		private KeyEvent oldEvent;
		
		/** 󥹥󥹤 */
		private HawkCanvasKeyListener()
		{
		}
		
		/**  */
		public void keyPressed(KeyEvent e)
		{
			boolean isAlt = ((e.getModifiers() & InputEvent.ALT_MASK) != 0);
			
			// ֤äƤ륤٥Ȥ̵뤹
			if (e.getWhen() + EVENT_DELAY < System.currentTimeMillis() &&
			    oldEvent != null &&
			    oldEvent.getKeyCode  () == e.getKeyCode  () &&
			    oldEvent.getModifiers() == e.getModifiers())
				return;
			oldEvent = e;
			
			if (isAlt) {
				switch (e.getKeyCode()) {
				case KeyEvent.VK_LEFT : e.consume(); listener.back   (); break;
				case KeyEvent.VK_RIGHT: e.consume(); listener.forward(); break;
				}
			} else {
				switch (e.getKeyCode()) {
				case KeyEvent.VK_LEFT     :
				case KeyEvent.VK_RIGHT    :
				case KeyEvent.VK_UP       :
				case KeyEvent.VK_DOWN     :
				case KeyEvent.VK_PAGE_DOWN:
				case KeyEvent.VK_PAGE_UP  :
				case KeyEvent.VK_HOME     :
				case KeyEvent.VK_END      :
				case KeyEvent.VK_SPACE    :
					e.consume();
					synchronized (canvasSize) {
						int x = position.x;
						int y = position.y;
						switch (e.getKeyCode()) {
						case KeyEvent.VK_LEFT     : x += charScale.width ; break;
						case KeyEvent.VK_RIGHT    : x -= charScale.width ; break;
						case KeyEvent.VK_UP       : y -= charScale.height; break;
						case KeyEvent.VK_DOWN     : y += charScale.height; break;
						case KeyEvent.VK_PAGE_DOWN: x += (viewportSize.width - charScale.width); break;
						case KeyEvent.VK_PAGE_UP  : x -= (viewportSize.width - charScale.width); break;
						case KeyEvent.VK_HOME     : x = 0; y = 0; break;
						case KeyEvent.VK_END      : x = canvasSize.width - viewportSize.width; y = 0; break;
						case KeyEvent.VK_SPACE    : x += (viewportSize.width - charScale.width) * (!e.isShiftDown() ? 1 : -1); break;
						}
						setScrollPosition(x, y);
					}
					break;
				case KeyEvent.VK_ESCAPE:
					e.consume();
					{
						if (listener != null)
							listener.stop();
					}
					break;
				}
			}
		}
	}
	
//### HawkCanvasComponentListener
	/** ݡͥȥϥɥ */
	private class HawkCanvasComponentListener
		extends ComponentAdapter
	{
		/** 󥹥󥹤 */
		private HawkCanvasComponentListener()
		{
		}
		
		/** ѹ */
		public void componentResized(ComponentEvent e)
		{
			boolean reload = false;
			
			synchronized (canvasSize) {
				synchronized (viewportSize) {
					Dimension size = canvas.getSize();
					
					reload = (canvasSize.width > 0 && viewportSize.height != size.height);
					viewportSize.width  = size.width ;
					viewportSize.height = size.height;
					viewportSize.notifyAll();
				}
				
				horizontal.setMaximum(Math.max(canvasSize.width , viewportSize.width ));
				vertical  .setMaximum(Math.max(canvasSize.height, viewportSize.height));
				horizontal.setVisibleAmount (viewportSize.width );
				vertical  .setVisibleAmount (viewportSize.height);
				horizontal.setBlockIncrement(viewportSize.width  - charScale.width );
				vertical  .setBlockIncrement(viewportSize.height - charScale.height);
				
				if (horizontalAdded)
					fixScrollbar(horizontalAdded, canvasSize.height > viewportSize.height);
			}
			
			if (reload && listener != null && listener.canReload())
				listener.reload(false);
		}
	}
	
//### HawkCanvasMouseListener
	/** ޥ٥ȥϥɥ */
	private class HawkCanvasMouseListener
		extends MouseAdapter
	{
		/** 󥹥󥹤 */
		private HawkCanvasMouseListener()
		{
		}
		
		/** å */
		public void mouseClicked(MouseEvent e)
		{
			e.getComponent().requestFocus();
			
			// ġå
			if (itemMap != null)
				setupToolTip(0, e.getX(), e.getY());
			
			if (listener == null)
				return;
			
			currentLink  = getLinkURL (e.getX(), e.getY());
			currentImage = getImageURL(e.getX(), e.getY());
			
			if (e.isPopupTrigger() ||
			    ((e.getModifiers() & InputEvent.BUTTON3_MASK) == InputEvent.BUTTON3_MASK)) {
				
				popupMenu.removeAll();
				
				if (currentLink == null && currentImage == null) {
					menuItems[MENU_MAIN_BACK_INDEX   ].setEnabled(listener.canBack   ());
					menuItems[MENU_MAIN_FORWARD_INDEX].setEnabled(listener.canForward());
					menuItems[MENU_MAIN_STOP_INDEX   ].setEnabled(listener.canStop   ());
					menuItems[MENU_MAIN_RELOAD_INDEX ].setEnabled(listener.canReload ());
					((CheckboxMenuItem)menuItems[MENU_MAIN_OPTION_IMAGE_INDEX   ]).setState(!option.getLoadImage    ());
					((CheckboxMenuItem)menuItems[MENU_MAIN_OPTION_BAR_INDEX     ]).setState(!option.getShowScrollbar());
					((CheckboxMenuItem)menuItems[MENU_MAIN_OPTION_SPINGIF_INDEX ]).setState( option.getSpinGifImage ());
					((CheckboxMenuItem)menuItems[MENU_MAIN_OPTION_SPINJPEG_INDEX]).setState( option.getSpinJpegImage());
					
					appendPopupMenuItem(mainMenuItems);
				}
				if (currentLink != null) {
					appendPopupMenuItem(linkMenuItems);
				}
				if (currentImage != null) {
					appendPopupMenuItem(imageMenuItems);
				}
				
				popupMenu.show(e.getComponent(), e.getX(), e.getY());
				
				e.consume();
				return;
			}
			
			if (currentLink != null) {
				// 󥯾򥯥å줿
				if ((e.getModifiers() & InputEvent.BUTTON1_MASK) == InputEvent.BUTTON1_MASK ||
				    (e.getModifiers() & InputEvent.BUTTON2_MASK) == InputEvent.BUTTON2_MASK) {
					resetStatus();
					
					listener.openHawk(new Request(currentLink, null, request.getDocument().url, null,
					                              e.isShiftDown(),
					                              ((e.getModifiers() & InputEvent.BUTTON2_MASK) == InputEvent.BUTTON2_MASK),
					                              Request.CACHE_NORMAL));
				} else {
//System.out.println("no?");
				}
				
				e.consume();
			}
		}
		
		/** ޥФ */
		public void mouseExited(MouseEvent e)
		{
			resetStatus();
		}
	}
	
//### HawkCanvasMouseMotionListener
	/** ޥ⡼ϥɥ */
	private class HawkCanvasMouseMotionListener
		extends MouseMotionAdapter
	{
		/** 󥹥󥹤 */
		private HawkCanvasMouseMotionListener()
		{
		}
		
		/** ޥư */
		public void mouseMoved(MouseEvent e)
		{
			int    cursor = Cursor.DEFAULT_CURSOR;
			String status = null;
			
			synchronized (canvasSize) {
				if (itemMap == null)
					return;
				
				// ġå
				cursor = setupToolTip(cursor, e.getX(), e.getY());
				
				// 󥯾夫ɤå
				URL href = getLinkURL(e.getX(), e.getY());
				if (href != null) {
					cursor = Cursor.HAND_CURSOR;
					status = href.toString();
				}
			}
			
			e.consume();
			setTemporaryCursor(cursor);
			hawkContext.setTemporaryStatus(status);
		}
	}
	
//### MenuActionListner
	/** ˥塼ѤΥꥹ */
	private class MenuActionListner
		implements ActionListener, ItemListener
	{
		private int index = 0;
		
		/** ˥塼ꥹ  */
		private MenuActionListner(int index)
		{
			this.index = index;
		}
		
		/** ϥɥ */
		public void actionPerformed(ActionEvent e)
		{
			if (listener != null) {
				boolean isShift = ((e.getModifiers() & InputEvent.SHIFT_MASK) != 0);
				boolean isCtrl  = ((e.getModifiers() & InputEvent.CTRL_MASK ) != 0);
				
				/// MENU
				switch (index) {
				case MENU_MAIN_BACK_INDEX   : listener.back   (); break;
				case MENU_MAIN_FORWARD_INDEX: listener.forward(); break;
				case MENU_MAIN_STOP_INDEX   : listener.stop   (); break;
				case MENU_MAIN_RELOAD_INDEX : listener.reload (isCtrl); break;
				case MENU_MAIN_INFO_INDEX   : ; break;
				case MENU_LINK_COPY_INDEX   : copyClipboard(currentLink.toString()); break;
				case MENU_IMAGE_OPEN_INDEX  : listener.openHawk(new Request(currentImage, null, request.getDocument().url, null, isShift, false, Request.CACHE_NORMAL)); break;
				case MENU_IMAGE_COPY_INDEX  : copyClipboard(currentImage.toString()); break;
				}
			}
		}
		
		/** ϥɥ */
		public void itemStateChanged(ItemEvent e)
		{
			boolean selected = (e.getStateChange() == ItemEvent.SELECTED);
			
			/// MENU
			switch (index) {
			case MENU_MAIN_OPTION_IMAGE_INDEX   :
				option.setLoadImage(!selected);
				break;
			case MENU_MAIN_OPTION_BAR_INDEX     :
				setVisibleScrollbar(!selected);
				break;
			case MENU_MAIN_OPTION_SPINGIF_INDEX :
				option.setSpinGifImage(selected);
				break;
			case MENU_MAIN_OPTION_SPINJPEG_INDEX:
				option.setSpinJpegImage(selected);
				break;
			}
		}
	}
	
//### ScrollbarListener
	/** Сꥹ */
	private class ScrollbarListener
		implements AdjustmentListener
	{
		private static final int HORIZONTAL = 0;
		private static final int VERTICAL   = 1;
		
		private boolean        isHorizontal;
		private PanelScrollbar scrollbar;
		
		/** 󥹥󥹤 */
		private ScrollbarListener(int orientation, PanelScrollbar scrollbar)
		{
			this.isHorizontal = (orientation == HORIZONTAL);
			this.scrollbar    = scrollbar;
		}
		
		/** ͤѹ */
		public void adjustmentValueChanged(AdjustmentEvent e)
		{
			// ٥ȤͤǤϤʤߤͤ򸵤˰֤ꤹ
			// ϡ٥ȯ塢ƤӽФޤǤ˥饰뤿
			synchronized (canvasSize) {
				if (isHorizontal)
					position.x = scrollbar.getMaximum() - scrollbar.getVisibleAmount() - scrollbar.getValue();
				else
					position.y = scrollbar.getValue();
				
				canvas.movePosition(position.x, position.y);
			}
		}
	}
}
