/* ----- BEGIN LICENSE BLOCK -----
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Kagetaka Libraries.
 *
 * The Initial Developer of the Original Code is Hizuya Atsuzaki
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Hizuya Atsuzaki <hizuya@hizlab.net>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ----- END LICENSE BLOCK ----- */
package net.hizlab.kagetaka.viewer;

import net.hizlab.kagetaka.option.ViewerOption;
import net.hizlab.kagetaka.rendering.Option;
import net.hizlab.kagetaka.util.CharList;

import java.awt.Font;

/**
 * ƥѤΥץǤ
 * 
 * @author  <A HREF="mailto:hizuya@hizlab.net">Hizuya Atsuzaki</A>
 * @version $Revision: 1.1 $
 */
class LocalizedOption
	extends Option
{
	/** @serial ӥ塼ץ */
	private ViewerOption option;
	
	/** @serial ɤ뤫ɤ */
	private boolean  loadImage           = true;
	/** @serial Сɽ뤫ɤ */
	private boolean  showScrollbar       = true;
	/** @serial GIF ž뤫ɤ */
	private boolean  spinGifImage        = false;
	/** @serial JPEG ž뤫ɤ */
	private boolean  spinJpegImage       = false;
	
	/**
	 * 󥹥󥹤ޤ
	 * 
	 * @param     option ١Ȥʤ륪ץ
	 */
	LocalizedOption(ViewerOption option)
	{
		this.option = option;
		
		setLoadImage    (option.getLoadImage    ());
		setShowScrollbar(option.getShowScrollbar());
		setSpinGifImage (option.getSpinGifImage ());
		setSpinJpegImage(option.getSpinJpegImage());
	}
	
	/** {@inheritDoc} */    public String   getInputStreamParser  () { return option.getInputStreamParser  (); }
	/** {@inheritDoc} */    public String[] getFilterParsers      () { return option.getFilterParsers      (); }
	/** {@inheritDoc} */    public Font     getDefaultFont        () { return option.getDefaultFont        (); }
	/** {@inheritDoc} */    public Font     getDefaultFixedFont   () { return option.getDefaultFixedFont   (); }
	/** {@inheritDoc} */    public double   getFontPerPixel       () { return option.getFontPerPixel       (); }
	/** {@inheritDoc} */    public CharList getCharsSpinRight     () { return option.getCharsSpinRight     (); }
	/** {@inheritDoc} */    public CharList getCharsSpinLtrb      () { return option.getCharsSpinLtrb      (); }
	/** {@inheritDoc} */    public CharList getCharsKinsokuHead   () { return option.getCharsKinsokuHead   (); }
	/** {@inheritDoc} */    public CharList getCharsKinsokuTail   () { return option.getCharsKinsokuTail   (); }
	/** {@inheritDoc} */ // public boolean  getLoadImage          () { return option.getLoadImage          (); }
	/** {@inheritDoc} */ // public boolean  getShowScrollbar      () { return option.getShowScrollbar      (); }
	/** {@inheritDoc} */ // public boolean  getSpinGifImage       () { return option.getSpinGifImage       (); }
	/** {@inheritDoc} */    public double   getSpinGifAspectRatio () { return option.getSpinGifAspectRatio (); }
	/** {@inheritDoc} */    public int      getSpinGifMinWidth    () { return option.getSpinGifMinWidth    (); }
	/** {@inheritDoc} */ // public boolean  getSpinJpegImage      () { return option.getSpinJpegImage      (); }
	/** {@inheritDoc} */    public double   getSpinJpegAspectRatio() { return option.getSpinJpegAspectRatio(); }
	/** {@inheritDoc} */    public int      getSpinJpegMinWidth   () { return option.getSpinJpegMinWidth   (); }
	/** {@inheritDoc} */    public boolean  getSwapDecoration     () { return option.getSwapDecoration     (); }
}
